Subject: Re: reminder, 2.6.18 window...

From: Phil Dibowitz <[email-masked]>
Date: Wed, 24 May 2006 12:14:42 -0700

On Wed, May 24, 2006 at 03:05:54PM -0400, Jeff Garzik wrote:
> Phil Dibowitz wrote:
> >On Wed, May 24, 2006 at 02:23:05PM -0400, Jeff Garzik wrote:
> >>I disagree that we should bother about clearing statistics.  It always 
> >>adds more complication than necessary.  Few (if any) other statistics in 
> >>Linux permit easy clearing, often because adding operations other than 
> >>'increment' or 'read' requires adding expensive spinlocks or atomic 
> >>operations.
> >
> >Every networking device in the world supports clearing interface 
> >statistics.
> >Why should linux not be able to do the most basic operation on any
> >cisco/juniper/enterasys/whatever managed switch or router?
> >
> >It's a common operation on a network interface, I don't see why this is a
> >concern.
> >
> >When I'm debugging a networking issue On a cluster of hundreds and hundreds
> >of machines at work, I want to be able to reset them all quickly, and get a
> >rough idea of if they're all climbing, if they're all climbing at the same
> >rate, etc. And being able to do "for i in `cat hostlist`; do ssh $i 
> >ethtool -z
> >eth0; done" is really, really, REALLY, useful.
> 
> Obtaining the difference between two numbers is not that difficult.
> 
> Given any method of clearing statistics across your cluster, I'm certain 
> you can come up with a similar method of obtaining the current statistic 
> (the baseline).

Right, I'm aware there are other ways of doing this - I've written scripts to
record a hundreds of numbers, and then subtract them from each other. But
those scripts are work arounds for a feature _lacking_ in the kernel. A
feature that, as I've mentioned, is supported on any piece of networking gear
(and of course, lets not forget there's a specific option in the kernel config
*just* for "behave like a router").

If my patch was invasive and broke things, I would understand the hesitation,
but this is a feature that allows people to *choose* to do this if they need
to and the code is pretty self-contained.

-- 
Phil Dibowitz                             [email-masked]
Freeware and Technical Pages              Insanity Palace of Metallica
http://www.phildev.net/                   http://www.ipom.com/

"They that can give up essential liberty to obtain a little temporary
safety deserve neither liberty nor safety."
 - Benjamin Franklin, 1759